--
-- Author: Ct5719
-- Date: 2015-5-23
-- main.lua 入口函数。
-- 
-- 本文件不可热更新。
-- 为了更准确的记录错误，所以，后续的lua中，重载了__G__TRACKBACK__方法，这里就先不改动了。
--

-- 避免内存泄漏
collectgarbage("setpause", 100)
collectgarbage("setstepmul", 5000)

-- 打印全局错误处理
function __G__TRACKBACK__(errorMessage)
    CCLuaLog("----------------------------------------")
    CCLuaLog("LUA ERROR: "..tostring(errorMessage).."\n")
    CCLuaLog(debug.traceback("", 2))
    CCLuaLog("----------------------------------------")
end

--CCLuaLoadChunksFromZip("res/framework_precompiled.zip")
	
-- 保护模式运行
xpcall(function()
    -- 先删除下可写目录中的version_root.lua，以防万一这个文件被热更新出去。
    local path = CCFileUtils:sharedFileUtils():getWritablePath();
    if CCApplication:sharedApplication():getTargetPlatform() == kTargetWindows then
        path = "../Documents/";
    end
    
    os.remove(path.."res/version_root.lua");
    os.remove(path.."res/version_root.luac");

    -- 包含version_root文件，检查下版本号。如果发现（VERSION_ROOT>VERSION_UP）的时候，要删除热更下来的所有文件。如此才能保证加载运行的都是包里面的最新文件。
    require("res.version_root");
    xgAppVersion.checkVersion();

    require("res.scripts.game")
    game.startup()
end, __G__TRACKBACK__)
