--
-- Author: Ct5719
-- Date: 2015-5-23
-- version_root.lua 发布版本号。
--
-- 本文件不可热更新。
-- 发布完整包的时候，才会改变次版本号。
-- 如果发现此版本号大于更新版本号（VERSION_ROOT>VERSION_UP）的时候，要删除热更下来的所有文件。
--
VERSION_ROOT = "1.0.3.438"


-- 版本号模块。
xgAppVersion = {}

-- 检查版本号，如果VERSION_ROOT>VERSION_UP;则表示当前的客户端比较新，要删除临时文件目录下的内容。
function xgAppVersion.checkVersion()
    require "res.version_up"

    -- print(package.preload);
    --print(package.loaded);

    --for k in pairs(package.loaded) do 
    --    print(k);
    --end

    local nRet = xgAppVersion.CompareVersions(VERSION_ROOT, VERSION_UP);
    if nRet==1 then
        local upPath = CCFileUtils:sharedFileUtils():getWritablePath().."res";
        local sharedApplication = CCApplication:sharedApplication()
        local target = sharedApplication:getTargetPlatform()
        if target == kTargetWindows then
             XGDeleteDirectory("../Documents/res", true);
        elseif target == kTargetMacOS then

        elseif target == kTargetAndroid then
            XGDeleteDirectory(upPath, true);
        elseif target == kTargetIphone or target == kTargetIpad then
            XGDeleteDirectory(upPath, true);
        end

        -- 因为从可写目录删除了所有文件，所以必须重新require此前加载过的文件，目前只有一个，就是"res.version_up"
        package.loaded["res.version_up"] = nil;
    end
end


-- 版本比较：比较app版本和本地版本谁新。0表示版本号一样；1表示app的新；-1表示up的新。
function xgAppVersion.CompareVersions(versionApp, versionUp)
    -- 按.号分隔。
	local versionList1 = xgAppVersion.split(versionApp, ".");
	local versionList2 = xgAppVersion.split(versionUp, ".");
	local count=0;
    -- 看哪个版本号多。
	if #versionList1 > #versionList2 then
		count = #versionList1;
	else
		count = #versionList2;
	end	
    	
	for i=1, count do	
        local app = tonumber(versionList1[i]) or 0;
        local up = tonumber(versionList2[i]) or 0;
		if app > up then
			return 1;
		elseif app < up then
			return -1;
		end
	end
    return 0;
end	

-- 类似的方法，在functions里面就有了，但还是拷贝一份到这里，require的越少越好。
function xgAppVersion.split(str, delimiter)
    if (delimiter=='') then return false end
    local pos,arr = 0, {}
    -- for each divider found
    for st,sp in function() return string.find(str, delimiter, pos, true) end do
        table.insert(arr, string.sub(str, pos, st - 1))
        pos = sp + 1
    end
    table.insert(arr, string.sub(str, pos))
    return arr
end